#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "glsphyl_fn.h"
int main(int argc, char **argv)
{
  FILE *infile,*paramfile,*treefile,*Qfile,*binfile,*ratefile,*covtree;
  FILE *covfile,*ocovfile;
  char (*name)[11],aaRmat[80],*tstring,tree[10000];
  int ibin=0;
  int numsp,nsite,nrates,i,nchar,*seq,ntrees,probwt,nneg,not_used;
  int npair,*start,xcol,itree,*Xi,model,smodel,ncatG,*nxy,*ind,nchar2,neig,*nv;
  double *dmat,*sigma,*fr,alpha,*betav,*utreec,*Root,*Offdiag,*yt,minedge=1.0e-12;
  double *rate,*prob,kappa,*y,*X,*ss,*M,*Mp,*Mpp,*W,*Lam,*dmatt,*U,*utreecs;
  double *Q,*R;

/*   clock_t cstart, end; */
/*   double cpu_time_used; */
/*   cstart = clock(); */

  /* set parameters */
  paramfile = fopene(argv[--argc],"r","control file not available\n");

  nneg = 0; /* indicates which routine gls_paramf is being called from */
  gls_paramf(paramfile,&treefile,&nchar,&model,aaRmat,&Qfile,&kappa,
	     &alpha,&ncatG,&nrates,&ratefile,&infile,&ntrees,&neig,&probwt,
	     &not_used,&covtree,&nneg,&not_used,&covfile,&ocovfile);
  fscanf(infile, "%i %i", &numsp, &nsite);
/*   printf("%i %i\n",numsp,nsite); */
  npair = (numsp * (numsp - 1))/2;
  if(neig < 0) neig=npair;
  xcol = 2*numsp - 3;
  nchar2 = nchar*nchar;
  if(alpha > 0 && ncatG > 0) nrates=ncatG;

  utreec = (double *) malloc((size_t) (numsp-1)*4*sizeof(double));
  fr = (double *) malloc((size_t) nchar*sizeof(double));
  dmat = (double *) malloc((size_t) numsp*numsp*sizeof(double));
  dmatt = (double *) malloc((size_t) numsp*numsp*sizeof(double));
  name = (char (*)[11]) malloc((size_t) numsp*sizeof(*name));
  betav = (double *) malloc((size_t) (2*numsp-3)*sizeof(double));
  rate = (double *) malloc((size_t) nrates*sizeof(double));
  prob = (double *) malloc((size_t) nrates*sizeof(double));
  seq = (int *) malloc((size_t) numsp*nsite*sizeof(int));
  sigma = (double *) malloc((size_t) npair*npair*sizeof(double));
  U = (double *) malloc((size_t) npair*npair*sizeof(double));
  Root = (double *) malloc((size_t) npair*sizeof(double));
  Offdiag = (double *) malloc((size_t) npair*npair*sizeof(double));
  start = (int *) malloc((size_t) (ntrees+1)*sizeof(int));
  tstring = (char *) malloc((size_t) ntrees*10000*sizeof(char));
  M = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  Mp = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  Mpp = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  y = (double *) malloc((size_t) npair*sizeof(double));
  yt = (double *) malloc((size_t) npair*sizeof(double));
  Xi = (int *) malloc((size_t) npair*xcol*sizeof(int));
  X = (double *) malloc((size_t) npair*xcol*sizeof(double));
  ss = (double *) malloc((size_t) ntrees*sizeof(double));
  ind = (int *) malloc((size_t) ntrees*sizeof(int));
  nxy = (int *) malloc((size_t) npair*nchar2*sizeof(int));
  nv = (int *) malloc((size_t) npair*sizeof(int));
  utreecs = (double *) malloc(ntrees*(numsp-1)*4*sizeof(double));
  Q = (double *) malloc(npair*npair*sizeof(double));
  R = (double *) malloc(xcol*xcol*sizeof(double));

  mladistf_getdp(infile,Qfile,ratefile,model,nchar,
		 numsp,nsite,ncatG,kappa,&alpha,
		 aaRmat,&nrates,&smodel,name,seq,
		 fr,&W,&Lam,rate,prob);
  
  /* trees */
  read_trees(treefile, ntrees, tstring, start); 
  fclose(treefile);
  
  /* ML distance calculation */
  mladistf(smodel,nchar,nsite,numsp,seq,nrates,rate,prob,1,&alpha,
	   fr,W,Lam,nv,nxy,M,Mp,Mpp,dmat);
  if(ibin){
    binfile=fopen("tmp.bout","wb");
    fwrite(dmat,sizeof(double),numsp*numsp,binfile);
  }
  /* pr_distmat(stdout,numsp,name,dmat); */
  if(nneg == 2) exit(0); /* temporary */
  
  /* covariance matrix for distances */
  if(probwt==0 || probwt==1 || probwt==3 || probwt==5)
    covmldistf(nchar,nsite,numsp,seq,nxy,nv,nrates,rate,prob,alpha,
	       fr,smodel,W,Lam,M,Mp,Mpp,dmat,probwt,covtree,
	       name,sigma,U,Root);
  if(ibin && (probwt==0 || probwt==1 || probwt==3 || probwt==5))
    fwrite(sigma,sizeof(double),npair*npair,binfile);

  /* for pairwise tests comparing covariance matrices with probwt=0,1 */
  if(probwt==4){ 
    covmldistf(nchar,nsite,numsp,seq,nxy,nv,nrates,rate,prob,alpha,
	     fr,smodel,W,Lam,M,Mp,Mpp,dmat,0,covtree,name,sigma,U,Root);
    fwrite(sigma,sizeof(double),npair*npair,binfile);
    covmldistf(nchar,nsite,numsp,seq,nxy,nv,nrates,rate,prob,alpha,
	     fr,smodel,W,Lam,M,Mp,Mpp,dmat,1,covtree,name,sigma,U,Root);
    fwrite(sigma,sizeof(double),npair*npair,binfile);
    exit(0);
  }
/*   wmate16(stdout,npair,npair,sigma); */
  if(nneg == 3) exit(0); /* temporary */

  /* Obtain GLS test statistics for each tree */
  start[0] = 0;
  if(probwt != 2){
    gety(numsp, dmat, y);
    scaly_eig(neig, npair, Root, U, y, yt);
  }

  for(itree = 0; itree < ntrees; itree++){

    strcpy(tree, &tstring[start[itree]]);
/*     printf("%s\n",tree); */

    if(probwt==2){
      treecsnl(numsp, tree, name, utreec, 1);
      tree2dmat(numsp,dmat,utreec,dmatt,minedge);  
      dnacov_prtree(nchar,nsite,numsp,seq,nxy,nv,nrates,rate,prob,alpha,fr,
		    smodel,W,Lam,dmatt,sigma);
      if(ibin && itree==0) fwrite(sigma,sizeof(double),npair*npair,binfile);
      memcpy(U,sigma,npair*npair*sizeof(double));
      eigenRealSym(U, npair, Root, Offdiag);
/*       wrow(stdout,npair,Root,1); */
      gety(numsp, dmat, y);
      scaly_eig(neig, npair, Root, U, y, yt);
    }

    memcpy(yt,y,neig*sizeof(double));
/*     printf("%s\n",tree); */
    getXmat(tree, numsp, name, Xi);
/*     for(j = 0; j < npair; j++){ */
/*       for(i = 0; i < xcol; i++) printf("%2i",Xi[j+i*npair]); */
/*       printf("\n"); */
/*     } */
/*     exit(0); */
    
    scalX_eig(npair, neig, xcol, Xi, Root, U, X);
/*     printf("%i %i %i ",npair,neig,xcol); */
/*     wrow(stdout,neig,y,1); */
/*     wmat(stdout,neig,xcol,X); */
    if(nneg==1){
      ss[itree] = gls_eig_opt(neig, xcol, yt, X, betav);
    }
    else{
      simp_qr(npair,xcol,X,Q,R);
      ss[itree] = lsqr(npair,xcol,1,Q,R,yt,betav);
    }
/*     wrow(stdout,xcol,betav,1); */
    Xb2utreec(numsp,Xi,betav,&utreecs[itree*(numsp-1)*4]);
/*     pr_utreec(stdout,numsp,&utreecs[itree*(numsp-1)*4]); */
/*     printf("%f\n",ss[itree]); */
/*      fprintf(betafile, "%i ", itree); */
  }
  
  if(ibin) fclose(binfile);
  /* order the trees according to their GLS test stat and output */
  dorder(ntrees, ss, ind);
  for(i = 0; i < ntrees; i++){
    ut2n(numsp,&utreecs[ind[i]*(numsp-1)*4],name,tree);
    printf("%f %f %s %i\n", ss[ind[i]],
	   1-pchisq(ss[ind[i]], neig - (2*numsp - 3)),tree,ind[i]);
  }

/*   end = clock(); */
/*   cpu_time_used = ((double) (end - cstart)) / CLOCKS_PER_SEC; */
/*   printf("CPU time: %f\n",cpu_time_used); */

  return(0);
}
