#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
extern void dgeqrf_();
extern void dorgqr_();
extern int nnls_();
#define InverseCDFGamma(prob,alpha,beta) InverseCDFChi2(prob,2.0*(alpha))/(2.0*(beta))
#define SIGN(a,b) ((b) >= 0.0 ? fabs(a) : -fabs(a))
#ifndef PI
   #define PI 3.14159265358979323846
#endif
void getyb(int npair, int nsim, double *v, double *sigma, double *yb);
FILE *fopene(char *filename, char *rw, char *err);
char get_param(int *k, char **arg, char *value);
char ctl_paraml(FILE *fp, char *opt, char *value, int *is_option);
int pmodel2smodel(int model, char *aaRmat, int nchar);
int bnewtr(double *a, double *b, double *x, double *f);
int l2i(char c);
int l2ip(char c);
int rseqf(FILE *fp, char *seq);
char ignore_whitespace_seqfile(FILE *infile);
void rinterleavef(FILE *infile, int *numsp, int *nsite, char name[][11], 
		  char *seq);
int rinterleave_block(FILE *infile, int numsp, int nsite, char name[][11], 
		       char *seq, int *initb);
void rinterleavef_nolim(FILE *infile, const int *numsp, const int *nsite, 
			char name[][11], char *seq);
void letter(int numsp, int nsite, char *seq);
int pchar_freqi(int nchar, int nsite, int *s1, int *s2, int *nxy);
void char_freq(int nchar, int numsp, int nsite, int *seq, double *freq);
int patt_freq(int numsp, int nsite, int *seq, int *count);
int all_sitepatt(int nchar, int ntaxa, int *patt);
void ou2nu(int numsp, double *outreec, double *utreec);
void utreec2bl(int ntaxa, double *utreec, double *bl);
void bl2utreec(int ntaxa, double *bl, double *utreec);
void gls_paramf(FILE *fp, FILE **treefile, int *nchar, int *model, 
		char *aaRmat, FILE **Qfile, double *kappa,  
		double *alpha, int *ncatG, int *nrate, FILE **ratefile, 
		FILE **seqfile, int *ntrees, int *neig, 
		int *probwt, int *need_pvalue,
		FILE **covtree, int *nneg, int *simwt, 
		FILE **covfile, FILE **ocovfile);
double p3LSp(int nchar, int *s, double *fr, double *M);
double p4LSp(int nchar, int top, int *s, double *fr, double *M);
double p4LSp_eff(int nchar, int top, int *s, double *fr, double *M);
void pr3LS(int nchar, int numsp, int *s3, int *jv, double *dm, int smodel, 
	   int nrates, double *rate, double *wt, double alpha, 
	   double *fr, double *W, double *Lam, double *px);
void pr4LS(int nchar, int numsp, int *s4, int *jv, double *dm, int smodel, 
	   int nrates, double *rate, double *wt, double alpha, 
	   double *fr, double *W, double *Lam, double *px);
void pr3LStree(int nchar, int *s3, double d01, double d02, double d12, 
	       int smodel, int nrates, double *rate, double *wt, double alpha, 
	       double *fr, double *W, double *Lam, double *px);
void pr4LStree(int nchar, int *s4, 
	       double d01, double d02, double d03, double d12, 
	       double d13, double d23, int smodel, 
	       int nrates, double *rate, double *wt, double alpha, 
	       double *fr, double *W, double *Lam, double *px);
void pr4LStree_fprob(int nchar, int top, double *M, double *Ma);
double p4LSp_eff2(int nchar, int top, int t2, int t3, int *s, double *fr, 
		double *M,  double *Ma);
void pr4LStree_eff(int nchar, int *s4, 
		   double d01, double d02, double d03, double d12, 
		   double d13, double d23, int smodel, 
		   int nrates, double *rate, double *wt, double alpha, 
		   double *fr, double *W, double *Lam, double *px);
void tree2dmat(int numsp, double *dmat, double *utreec, double *dmatt, 
	       double minedge);
double utreecdpair(int r, int l, int ntaxa, double *utreec);
void utreec2dmat(int ntaxa, double *utreec, double *dmat);
void sigma_calc(int nsite, int *ngap, int npair, double *sigma, double *fp, 
		double *fpp, int pdef);
void dpair(int nchar, int nsite, int *s1, int *s2, int nrate, double *prob, 
	   double *M, double *Mp, double *Mpp, int *ngap, double *fp, 
	   double *fpp);
double dpair_pr(int nchar, int nsite, int *nxy, int nrate, double *prob, 
		double *fr, double *M, double *Mp, double *fp, int pr);
double dpair_var(int nchar, int nsite, int *nxy, int nrate, double *prob, 
		 double *fr, double *M, double *Mp, int pr);
void dnacov(int nchar, int nsite, int numsp, int *seq, int nrate, double *prob, 
	    double *M, double *Mp, double *Mpp,  
	    double *sigma, int pdef);
void  new_pair(int n, int *i, int *j);
void dnacov_fr(int nchar, int nsite, int numsp, int *seq, int *nxy, int *nv,
	       int nrate, double *prob, double *fr, double *M, double *Mp, 
	       double *sigma);
void dnacov_pr(int nchar, int nsite, int numsp, int *seq, int *nxy, int *nv,
	       int nrate, double *rate, double *prob, double alpha,
	       double *fr, int smodel, double *W, double *Lam, double *dm,
	       double *M, double *Mp, double *Mpp, double *sigma);
void dnacov_prtree(int nchar, int nsite, int numsp, int *seq, int *nxy, int *nv,
		   int nrate, double *rate, double *prob, double alpha,
		   double *fr, int smodel, double *W, double *Lam, double *dm,
		   double *sigma);
void covmldistf(int nchar, int nsite, int numsp, 
		int *seq, int *nxy, int *nv, 
		int nrates, double *rate, double *prob, double alpha, 
		double *fr, int smodel, double *W, double *Lam, 
		double *M, double *Mp, double *Mpp,
		double *dmat, int probwt, FILE *covtree, char (*name)[11],
		double *sigma, double *U, double *Root);
void varmldistf(int nchar, int numsp, int *nxy, int *nv, int nrate, 
		   double *prob, double *fr, double *M, double *Mp, 
		   int probwt, double *sigma);
void varmldistf_tree(int nchar, int numsp, int *nxy, int *nv, int nrate, 
		     double *rate, double *prob, double alpha, double *fr, 
		     int smodel, double *W, double *Lam, double *dmatt, 
		     double *sigma);
void wlssim(int ntaxa, double *y, double *sigma, int nchar, int smodel, 
	    double *fr, double *W, double *Lam, 
	    int nrate, double *rate, double *prob, double alpha,
	    int *nxy, int *nv, int probwt, int nsim, double *yb, double *v);
double wlssimp(int nsim, int npair, int xcol, double ssobs, double *yb, 
	       double *Q);
void gety(int numsp, double *d, double *y);
void scaly_eig(int npe, int npair, double *Root, double *U, double *y, 
	       double *yt);
void v_trans(int numsp, int *v, int *x);
void update_v(int numsp, int idx, int *v, double *uvec);
void create_Xmat(int numsp, double *utreec, int *X);
void getXmat(char *tstring, int numsp, char name[][11], int *X);
void scalX_eig(int npair, int npe, int xcol, int *Xi, double *Root, double *U, 
	       double *X);
void X2splits(int numsp, int *Xi, int *s);
void Xb2utreec(int numsp, int *Xi, double *beta, double *utreec);
void read_trees(FILE *treefile, int ntrees, char *tstring, int *start);
double gls_eig_opt(int np, int xcol, double *y, double *X, double *beta);
void makeprotfreqs(double *fr, double *W, double *Lam);
void chQ_freq(int nbin, double *W, double *Lam, double *fr, double *fro);
double int_elamrt(double t, double lam, double alpha, int deriv, double *de);
void pJCm(double t, int nchar, double *fr, int deriv, 
	    double *M, double *Mp, double *Mpp);
void pJCm_gen(double t, int nchar, double *fr, double *W, double *Lam, 
		int deriv, double *M, double *Mp, double *Mpp);
void pJCma(double t, int nchar, double *fr, int deriv, double alpha,
	   double *M, double *Mp, double *Mpp);
void pJCma_gen(double t, int nchar, double *fr, double *W, double *Lam, 
	       int deriv, double alpha, double *M, double *Mp, double *Mpp);
double muF81f(int nchar, double *fr);
void pF81m(double t, int nchar, double *fr, double mu, int deriv, 
	   double *M, double *Mp, double *Mpp);
void pF81m_gen(double t, int nchar, double *fr, double *mu, double *Lam, 
		 int deriv, double *M, double *Mp, double *Mpp);
void pF81ma(double t, int nchar, double *fr, double mu, int deriv, double alpha,
	   double *M, double *Mp, double *Mpp);
void pF81ma_gen(double t, int nchar, double *fr, double *mu, double *Lam, 
		int deriv, double alpha, double *M, double *Mp, double *Mpp);
int is_transitionf(int i, int j);
double muF84f(double K, double *fr);
void pF84m(double t, double mu, double K, double *fr, int deriv, 
	   double *M, double *Mp, double *Mpp);
void pF84m_gen(double t, int nchar, double *fr, double *mu, double *K, 
	       int deriv, double *M, double *Mp, double *Mpp);
void pF84ma(double t, double mu, double K, double *fr, int deriv, double alpha,
	    double *M, double *Mp, double *Mpp);
void pF84ma_gen(double t, int nchar, double *fr, double *mu, double *K, 
		int deriv, double alpha, double *M, double *Mp, double *Mpp);
double tt2K(double R, double *fr);
double K2tt(double K, double *fr);
double muHKYf(double kappa, double *fr);
void pHKYm(double t, int nchar, double *fr, double mu, double kappa,
	   int deriv, double *M, double *Mp, double *Mpp);
void pHKYm_gen(double t, int nchar, double *fr, double *mu, double *kappa, 
	       int deriv, double *M, double *Mp, double *Mpp);
void pHKYma(double t, int nchar, double *fr, double mu, double kappa,
	    int deriv, double alpha, double *M, double *Mp, double *Mpp);
void pHKYma_gen(double t, int nchar, double *fr, double *mu, double *kappa, 
	       int deriv, double alpha, double *M, double *Mp, double *Mpp);
double tt2kappa(double R, double *fr);
double kappa2tt(double kappa,  double *fr);
void rmnegpv(int m, double *pv, int incp);
void rmnegtrans(int m, double *P);
void Q2frWLam(int nbin, double *Q, double *fr, double *W, double *Lam);
void pGTRm(double t, int nchar, double *fr, double *W, double *Lam, 
	   int deriv, double *M, double *Mp, double *Mpp);
void pGTRma(double t, int nchar, double *fr, double *W, double *Lam, 
	    int deriv, double alpha, double *M, double *Mp, double *Mpp);
int subst_model_setpm(int smodel,
		      void (*(*pm))(double t, int nchar, double *fr, 
				    double *W, double *Lam, int deriv, 
				    double *M, double *Mp, 
				    double *Mpp));
int subst_model_setpma(int smodel,
		       void (*(*pm))(double t, int nchar, double *fr, 
				     double *W, double *Lam, int deriv, 
				     double alpha,
				     double *M, double *Mp, double *Mpp));
int subst_model_setparam(int nchar, int smodel, double *fr, double *Qk,
			 double **W, double **Lam);
void transm_rate(int smodel, int nchar, int ntaxa, double *utreec, 
		 int nrate, double *rate, double alpha,
		 double *fr, double *W, double *Lam, int deriv, 
		 double *M, double *Mp, double *Mpp);
int mldist(double *a, double *b, double *t, double *fr,
	   double *M, double *Mp, double *Mpp,
	   int nchar, int *nxy, int nrate, double *wt, double *f);
void complf_pair(double *fr, double *M, double *Mp, double *Mpp, 
		 int nchar, int *nxy, int deriv, double *fp);
void complf(int smodel, int nchar, int ntaxa, double alpha, 
	    double *fr, double *W, double *Lam, int *nxy, double *dmat,
	    int deriv, double *M, double *Mp, double *Mpp, double *f);
double mladistf_pair(int smodel, int nchar, int *nxy, 
		   int nrate, double *rate, double *wt, double alpha, 
		   double *fr, double *W, double *Lam, 
		   double *M, double *Mp, double *Mpp, double *d);
void mladistf(int smodel, int nchar, int nsite, int ntaxa, int *seq, 
		  int nrate, double *rate, double *wt, 
		  int fix_alpha, double *alpha, 
		  double *fr, double *W, double *Lam, 
		  int *nv, int *nxy, double *M, double *Mp, double *Mpp, 
		  double *dmat);
void mladistf_paramf(FILE *fp, int *nchar, int *model, char *aaRmat, 
		     FILE **Qfile, double *kappa, double *alpha, int *ncatG, 
		     int *nrate, FILE **ratefile, int *fix_alpha, 
		     FILE **seqfile);
void mladistf_getdp(FILE *infile, FILE *Qfile, FILE *ratefile, int model, 
		   int nchar, int numsp, int nsite, int ncatG, double kappa, 
		   double *alpha, char *aaRmat, int *nrates, int *smodel, 
		   char name[][11], int *seq, double *fr, double **W, 
		   double **Lam, double *rate, double *prob);
double *cvec(int n);
int icomp(const int *a, const int *b);
void isort(int n, int *x);
double urand(void);
double ipow(double x, int n);
void rnorm(int n, double *v, double *se);
double pnorm(double x, double a, double b);
double pchisq(double x, int df);
int lstring(char * string);
void dorder(int n, double *x, int *o);
void iorder(int n, int *x, int *o);
int DiscreteGamma (double freqK[], double rK[], double alpha, double beta, int K, int dgammamean);
void error2 (char * message);
long factorial (int n);
double LnGamma (double x);
double InverseCDFNormal (double prob);
double InverseCDFChi2 (double prob, double v);
double IncompleteGamma (double x, double alpha, double ln_gamma_alpha);
int sqrtmat(int m, double *A, double *Ah);
void rmvnorm(int nsim, int m, double *mu, double *Sigma, double *V);
int read_tree(FILE *fp, char *tstring);
double get_dlist(char *tstr, int ss, int de, int *ssn, int *ls, int *le);
void underscore2blank(char *s);
char **treecs(int ntaxa, char *tstr, char names[][11], double *utreec, 
	      int has_names);
void treecsnl(int ntaxa, char *tstr, char names[][11], double *utreec, 
	      int has_names);
void read_treecsnl(FILE *treefile, int ntaxa, char names[][11], double *utreec, 
		   int has_names);
int eigenRealSym(double A[], int n, double Root[], double Offdiag[]);
void EigenSort(double d[], double U[], int n);
void HouseholderRealSym(double a[], int n, double d[], double e[]);
int EigenTridagQLImplicit(double d[], double e[], int n, double z[]);
int sp_char(char c);
void ch_name(int lstring, char *tstring, int i);
int has_bl(char *tstring);
void ch_labels_nbl(int ntaxa, char *tstring, char names[][11]);
void ch_labels(int ntaxa, char *tstring, char names[][11]);
int is_wsp(char c);
void rmblntree(char *tstring, int rwsp);
void nj(int numsp, double *d, double *ntree);
void nju(int numsp, double *d, double *ntree);
void split_leading1(int numsp, int *split);
void utreec2splits(int numsp, double *utreec, int *splits);
int ivsame(int n, int *x, int *y);
int up_usplitr(int numsp, int *nspl, int *split, int *usplits);
int split_sum(int numsp, int *split, int *row_idx);
void up_utree(int numsp, int join, int ssum, int *splits, int *row_idx, 
	      double *utreec);
void final_joins(int numsp, int *row_idx, double *utreec);
void splits2tree_bl(int numsp, int nspl, int *tree, int *usplits, double *bl, 
		    double *utreec);
void splits2tree_nobp(int numsp, int nspl, int *tree, int *usplits, 
		      double *utreec);
void rmexspce(int numsp, char names[][11]);
int ndig_intpart(double f);
char *ut2in(int numsp, double *utreec, char names[][11], char **ilabels);
void ut2n(int numsp, double *utreec, char names[][11], char *tstr);
void ut2nt(int numsp, double *utreec, char names[][11], char *tstr);
void simp_qr(int n, int p, double *X, double *Q, double *R);
double lsqr(int n, int p, int est_beta, double *Q, double *R, double *y, 
	    double *beta);
void getspl_spr(int ntaxa, int i, int **s, int *tree, int *usplits, int *terms);
void getAD(int ntaxa, int *s1, int *s2, int *dA, int *dD);
int checkC(int ntaxa, int *dA, int *dD, int *s);
void upsplit_spr(int ntaxa, int Ei, int *dA, int *s, int *sn);
void uptrees(int ntaxa, int *tree, int *ntrees, int *trees);
int is_newsf(int nsplits, int s, int *tree);
int is_termf(int ntaxa, int *sn);
void sprtrees(int ntaxa, int *tree, int *usplits, int *nspl, int *ntrees, 
	     int *trees);
int rfone(int ntaxa, int *t1, int *t2);
int rfdist(int ntaxa, int *t1, int *t2);
int rfonef(int ntaxa, int ls, int it, int *t);
int spr_search(int ntaxa, int ntrees, int bl, double *utreec, double *fnval, 
	       int *stop);
enum {
  alanine = 0, arginine, asparagine, aspartic, cysteine, 
  glutamine, glutamic, glycine, histidine, isoleucine,
  leucine, lysine, methionine, phenylalanine, proline,
  serine, threonine, tryptophan, tyrosine, valine
};
