#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "glsphyl_fn.h"
int main(int argc, char **argv)
{
  FILE *infile,*paramfile,*treefile,*Qfile,*ratefile,*covtree;
  FILE *covfile,*ocovfile;
  char (*name)[11],aaRmat[80],tree[10000];
  int numsp,nsite,nrates,i,nchar,*seq,ntrees,probwt,done,stop=0,ntreesa,nneg;
  int npair,xcol,*Xi,model,smodel,ncatG,*nxy,nchar2,neig,*nv,bl=1,not_used;
  double *dmat,*sigma,*fr,alpha,*betav,*utreec,*Root,*Offdiag,*yt;
  double *rate,*prob,kappa,*y,*X,*M,*Mp,*Mpp,*W,*Lam,*dmatt,*U,*fnval,*Q,*R;
  double minedge=1.0e-12;

  /* set parameters */
  paramfile = fopene(argv[--argc],"r","control file not available\n");

  nneg = 1; /* indicates which routine gls_paramf is being called from */
  gls_paramf(paramfile,&treefile,&nchar,&model,aaRmat,&Qfile,&kappa,
	     &alpha,&ncatG,&nrates,&ratefile,&infile,&ntrees,&neig,&probwt,
	     &not_used,&covtree,&nneg,&not_used,&covfile,&ocovfile);
  fscanf(infile, "%i %i", &numsp, &nsite);
  npair = (numsp * (numsp - 1))/2;
  if(neig < 0) neig=npair;
  xcol = 2*numsp - 3;
  nchar2 = nchar*nchar;
  if(alpha > 0 && ncatG > 0) nrates=ncatG;

  utreec = (double *) malloc((size_t) (numsp-1)*4*sizeof(double));
  fr = (double *) malloc((size_t) nchar*sizeof(double));
  dmat = (double *) malloc((size_t) numsp*numsp*sizeof(double));
  dmatt = (double *) malloc((size_t) numsp*numsp*sizeof(double));
  name = (char (*)[11]) malloc((size_t) numsp*sizeof(*name));
  betav = (double *) malloc((size_t) (2*numsp-3)*sizeof(double));
  rate = (double *) malloc((size_t) nrates*sizeof(double));
  prob = (double *) malloc((size_t) nrates*sizeof(double));
  seq = (int *) malloc((size_t) numsp*nsite*sizeof(int));
  sigma = (double *) malloc((size_t) npair*npair*sizeof(double));
  U = (double *) malloc((size_t) npair*npair*sizeof(double));
  Root = (double *) malloc((size_t) npair*sizeof(double));
  Offdiag = (double *) malloc((size_t) npair*npair*sizeof(double));
  M = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  Mp = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  Mpp = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  y = (double *) malloc((size_t) npair*sizeof(double));
  yt = (double *) malloc((size_t) npair*sizeof(double));
  Xi = (int *) malloc((size_t) npair*xcol*sizeof(int));
  X = (double *) malloc((size_t) npair*xcol*sizeof(double));
  nxy = (int *) malloc((size_t) npair*nchar2*sizeof(int));
  nv = (int *) malloc((size_t) npair*sizeof(int));
  fnval=(double *) malloc((size_t) 1*sizeof(double));
  Q=(double *) malloc((size_t) npair*npair*sizeof(double));
  R=(double *) malloc((size_t) xcol*xcol*sizeof(double));

  mladistf_getdp(infile,Qfile,ratefile,model,nchar,
		 numsp,nsite,ncatG,kappa,&alpha,
		 aaRmat,&nrates,&smodel,name,seq,
		 fr,&W,&Lam,rate,prob);
  
  /* ML distance calculation */
  mladistf(smodel,nchar,nsite,numsp,seq,nrates,rate,prob,1,&alpha,
	   fr,W,Lam,nv,nxy,M,Mp,Mpp,dmat);
  /* pr_distmat(stdout,numsp,name,dmat); */

  /* covariance matrix for distances */
  if(probwt != 2){
    if(covfile==NULL)
      covmldistf(nchar,nsite,numsp,seq,nxy,nv,nrates,rate,prob,alpha,
		 fr,smodel,W,Lam,M,Mp,Mpp,dmat,probwt,covtree,name,
		 sigma,U,Root);
    if(ocovfile!=NULL) fwrite(sigma,sizeof(double),npair*npair,ocovfile);
    if(covfile!=NULL) fread(sigma,sizeof(double),npair*npair,ocovfile);
    gety(numsp, dmat, y);
    scaly_eig(neig, npair, Root, U, y, yt);
  }

  /* starting tree */
  memcpy(dmatt,dmat,numsp*numsp*sizeof(double));
  if(treefile==NULL){
    nju(numsp,dmatt,utreec);
  }
  else{
    read_treecsnl(treefile,numsp,name,utreec,1);
  }

  /* optimize */
  done=-1;
  while(done <= 0){
    ntreesa=spr_search(numsp,ntrees,bl,utreec,fnval,&stop);
    if(!stop){

      if(probwt==2){
	tree2dmat(numsp,dmat,utreec,dmatt,minedge);  
	dnacov_prtree(nchar,nsite,numsp,seq,nxy,nv,nrates,rate,prob,alpha,fr,
		      smodel,W,Lam,dmatt,sigma);
	memcpy(U,sigma,npair*npair*sizeof(double));
	eigenRealSym(U, npair, Root, Offdiag);
	gety(numsp, dmat, y);
	scaly_eig(neig, npair, Root, U, y, yt);
      }

      memcpy(yt,y,neig*sizeof(double));
      create_Xmat(numsp, utreec, Xi);
      scalX_eig(npair, neig, xcol, Xi, Root, U, X);
      if(nneg==1)
	*fnval=gls_eig_opt(neig, xcol, yt, X, betav);
      else{
	simp_qr(npair,xcol,X,Q,R);
	*fnval = lsqr(npair,xcol,1,Q,R,y,betav);
      }
      Xb2utreec(numsp,Xi,betav,utreec);
      /* printf("%f\n",*fnval); */
    }
    if(stop){
      if(done < 0){
	/* printf("%i trees evaluated\n",ntreesa); */
	if(ntrees > ntreesa || ntrees==-1) ntrees=ntreesa;
	utreec = (double *) realloc(utreec,ntrees*(numsp-1)*4*sizeof(double));
	fnval = (double *) realloc(fnval,ntrees*sizeof(double));
      }
      done++;
    }
  }

  for(i = 0; i < ntrees; i++){
    printf("%f %f ",fnval[i],1-pchisq(fnval[i], neig - (2*numsp - 3)));
    ut2n(numsp,&utreec[i*(numsp-1)*4],name,tree);
    printf("%s ", tree);
/*     printf("\n"); */
/*     ut2nt(numsp,&utreec[i*(numsp-1)*4],name,tree); */
/*     printf("%s ", tree); */
    printf("\n");
  }
  return(0);
}
