#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "glsphyl_fn.h"
int main(int argc, char **argv)
{
  FILE *infile,*paramfile,*treefile,*Qfile,*binfile,*ratefile,*covtree;
  FILE *covfile,*ocovfile;
  char (*name)[11],aaRmat[80],*tstring,tree[10000];
  int numsp,nsite,nrates,i,j,nchar,*seq,ntrees,probwt,nneg,nsim=10000;
  int npair,*start,xcol,itree,*Xi,model,smodel,ncatG,*nxy,*ind,nchar2,neig,*nv;
  int simwt,est_beta=1,ibin=0,need_pvalue;
  double *dmat,*sigma,*fr,alpha,*betav,*utreec,*Root,*yt,minedge=1.0e-12;
  double *rate,*prob,kappa,*y,*X,*ss,*M,*Mp,*Mpp,*W,*Lam,*dmatt,*U,*utreecs;
  double *Q,*R,*tau,*work,*sq,*yb,*pval,*v;

/*   clock_t cstart, end; */
/*   double cpu_time_used; */
/*   cstart = clock(); */

  /* set parameters */
  paramfile = fopene(argv[--argc],"r","control file not available\n");

  nneg = 3; /* indicates which routine gls_paramf is being called from */
  gls_paramf(paramfile,&treefile,&nchar,&model,aaRmat,&Qfile,&kappa,
	     &alpha,&ncatG,&nrates,&ratefile,&infile,&ntrees,&neig,&probwt,
	     &need_pvalue,&covtree,&nneg,&simwt,&covfile,&ocovfile);
  if(simwt==0 || simwt==1) simwt += 6;
  fscanf(infile, "%i %i", &numsp, &nsite);
/*   printf("%i %i\n",numsp,nsite); */
  npair = (numsp * (numsp - 1))/2;
  if(neig < 0) neig=npair;
  xcol = 2*numsp - 3;
  nchar2 = nchar*nchar;
  if(alpha > 0 && ncatG > 0) nrates=ncatG;
  if(nneg < 0){
    est_beta=0;
    nneg=0;
  }

  utreec = (double *) malloc((size_t) (numsp-1)*4*sizeof(double));
  fr = (double *) malloc((size_t) nchar*sizeof(double));
  dmat = (double *) malloc((size_t) numsp*numsp*sizeof(double));
  dmatt = (double *) malloc((size_t) numsp*numsp*sizeof(double));
  name = (char (*)[11]) malloc((size_t) numsp*sizeof(*name));
  betav = (double *) malloc((size_t) (2*numsp-3)*sizeof(double));
  rate = (double *) malloc((size_t) nrates*sizeof(double));
  prob = (double *) malloc((size_t) nrates*sizeof(double));
  seq = (int *) malloc((size_t) numsp*nsite*sizeof(int));
  sigma = (double *) malloc((size_t) npair*npair*sizeof(double));
  v = (double *) malloc((size_t) npair*sizeof(double));
  start = (int *) malloc((size_t) (ntrees+1)*sizeof(int));
  tstring = (char *) malloc((size_t) ntrees*10000*sizeof(char));
  M = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  Mp = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  Mpp = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  y = (double *) malloc((size_t) npair*sizeof(double));
  yt = (double *) malloc((size_t) npair*sizeof(double));
  Xi = (int *) malloc((size_t) npair*xcol*sizeof(int));
  X = (double *) malloc((size_t) npair*xcol*sizeof(double));
  ss = (double *) malloc((size_t) ntrees*(npair-xcol)*sizeof(double));
  ind = (int *) malloc((size_t) ntrees*sizeof(int));
  nxy = (int *) malloc((size_t) npair*nchar2*sizeof(int));
  nv = (int *) malloc((size_t) npair*sizeof(int));
  utreecs = (double *) malloc(ntrees*(numsp-1)*4*sizeof(double));
  Q = (double *) malloc(npair*npair*sizeof(double));
  R = (double *) malloc(xcol*xcol*sizeof(double));
  tau = (double *) malloc(xcol*sizeof(double));
  work = (double *) malloc(npair*sizeof(double));
  sq = (double *) malloc((npair-xcol)*(npair-xcol)*sizeof(double));
  yb = (double *) malloc(nsim*npair*sizeof(double));
  pval = (double *) malloc(ntrees*sizeof(double));

  mladistf_getdp(infile,Qfile,ratefile,model,nchar,
		 numsp,nsite,ncatG,kappa,&alpha,
		 aaRmat,&nrates,&smodel,name,seq,
		 fr,&W,&Lam,rate,prob);
  
  /* trees */
  read_trees(treefile, ntrees, tstring, start); 
  fclose(treefile);
  
  /* ML distance calculation */
  mladistf(smodel,nchar,nsite,numsp,seq,nrates,rate,prob,1,&alpha,
	   fr,W,Lam,nv,nxy,M,Mp,Mpp,dmat);
  if(ibin){
    binfile=fopen("tmp.bout","wb");
    fwrite(dmat,sizeof(double),numsp*numsp,binfile);
  }

  /* variances used for weighting */
  varmldistf(nchar,numsp,nxy,nv,nrates,prob,fr,M,Mp,probwt,v);
  
  /* covariance matrix for distances */
  if(simwt != 2){
    if(covfile==NULL)
      covmldistf(nchar,nsite,numsp,seq,nxy,nv,nrates,rate,prob,alpha,
		 fr,smodel,W,Lam,M,Mp,Mpp,dmat,simwt,covtree,
		 name,sigma,U,Root);
    if(ocovfile!=NULL) fwrite(sigma,sizeof(double),npair*npair,ocovfile);
    if(covfile!=NULL) fread(sigma,sizeof(double),npair*npair,ocovfile);
    if(ibin) fwrite(sigma,sizeof(double),npair*npair,binfile);
  }

  start[0] = 0;
  gety(numsp, dmat, y);
  for(i = 0; i < npair; i++) y[i] /= sqrt(v[i]);
  if(simwt!=2 && need_pvalue) getyb(npair,nsim,v,sigma,yb);
  for(itree = 0; itree < ntrees; itree++){
    
    strcpy(tree, &tstring[start[itree]]);
    if(simwt==2){
      treecsnl(numsp, tree, name, utreec, 1);
      tree2dmat(numsp,dmat,utreec,dmatt,minedge); 
      dnacov_prtree(nchar,nsite,numsp,seq,nxy,nv,nrates,rate,prob,alpha,fr,
		    smodel,W,Lam,dmatt,sigma);
      if(ibin && itree==0) fwrite(sigma,sizeof(double),npair*npair,binfile);
      getyb(npair,nsim,v,sigma,yb);
    }

    getXmat(tree, numsp, name, Xi);
    for(i = 0; i < xcol; i++)
      for(j = 0; j < npair; j++) 
	X[j+i*npair] = Xi[j+i*npair]/sqrt(v[j]);
    
    if(need_pvalue || nneg<=0) simp_qr(npair,xcol,X,Q,R);
    if(nneg==1){
      memcpy(yt,y,npair*sizeof(double));
      ss[itree] = gls_eig_opt(npair, xcol, yt, X, betav);
    }

    if(nneg<=0){
      ss[itree] = lsqr(npair,xcol,est_beta,Q,R,y,betav);
    }
    if(est_beta)
      Xb2utreec(numsp,Xi,betav,&utreecs[itree*(numsp-1)*4]);
    if(need_pvalue)
      pval[itree] = wlssimp(nsim,npair,xcol,ss[itree],yb,&Q[xcol*npair]);
  }
  
  if(ibin) fclose(binfile);
  /* convert to p-values and output */
  dorder(ntrees, ss, ind);
  if(est_beta)
    for(i = 0; i < ntrees; i++){
      ut2n(numsp,&utreecs[ind[i]*(numsp-1)*4],name,tree);
      printf("%f ",ss[ind[i]]);
      if(need_pvalue) printf("%f ",pval[ind[i]]);
      printf("%s %i\n",tree,ind[i]);
    }
  else
    for(i = 0; i < ntrees; i++){
      printf("%f ",ss[ind[i]]);
      if(need_pvalue) printf("%f ",pval[ind[i]]);
      printf("(0:0.0,1:0.0,2:0.0); %i\n", ss[ind[i]], pval[ind[i]], ind[i]);
    }


/*   end = clock(); */
/*   cpu_time_used = ((double) (end - cstart)) / CLOCKS_PER_SEC; */
/*   printf("CPU time: %f\n",cpu_time_used); */

  return(0);
}
