#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "glsphyl_fn.h"
int main(int argc, char **argv)
{
  FILE *infile,*paramfile,*treefile,*Qfile,*ratefile,*covtree;
  FILE *covfile,*ocovfile;
  char (*name)[11],aaRmat[80],tree[10000];
  int numsp,nsite,nrates,i,j,nchar,*seq,ntrees,probwt,done,stop=0,ntreesa;
  int npair,xcol,*Xi,model,smodel,ncatG,*nxy,nchar2,neig,*nv,bl=1,not_used,nneg;
  double *dmat,*sigma,*fr,alpha,*betav,*utreec,*yt,*Q,*R,minedge=1.0e-12;
  double *rate,*prob,kappa,*y,*X,*M,*Mp,*Mpp,*W,*Lam,*dmatt,*fnval;

  /* set parameters */
  paramfile = fopene(argv[--argc],"r","control file not available\n");
  nneg = 2; /* indicates which routine gls_paramf is being called from */
  gls_paramf(paramfile,&treefile,&nchar,&model,aaRmat,&Qfile,&kappa,
	     &alpha,&ncatG,&nrates,&ratefile,&infile,&ntrees,&neig,&probwt,
	     &not_used,&covtree,&nneg,&not_used,&covfile,&ocovfile);
  fscanf(infile, "%i %i", &numsp, &nsite);
  npair = (numsp * (numsp - 1))/2;
  if(neig < 0) neig=npair;
  xcol = 2*numsp - 3;
  nchar2 = nchar*nchar;
  if(alpha > 0 && ncatG > 0) nrates=ncatG;

  utreec = (double *) malloc((size_t) (numsp-1)*4*sizeof(double));
  fr = (double *) malloc((size_t) nchar*sizeof(double));
  dmat = (double *) malloc((size_t) numsp*numsp*sizeof(double));
  dmatt = (double *) malloc((size_t) numsp*numsp*sizeof(double));
  name = (char (*)[11]) malloc((size_t) numsp*sizeof(*name));
  betav = (double *) malloc((size_t) (2*numsp-3)*sizeof(double));
  rate = (double *) malloc((size_t) nrates*sizeof(double));
  prob = (double *) malloc((size_t) nrates*sizeof(double));
  seq = (int *) malloc((size_t) numsp*nsite*sizeof(int));
  sigma = (double *) malloc((size_t) npair*sizeof(double));
  M = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  Mp = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  Mpp = (double *) malloc((size_t) npair*nchar2*nrates*sizeof(double));
  y = (double *) malloc((size_t) npair*sizeof(double));
  yt = (double *) malloc((size_t) npair*sizeof(double));
  Xi = (int *) malloc((size_t) npair*xcol*sizeof(int));
  X = (double *) malloc((size_t) npair*xcol*sizeof(double));
  nxy = (int *) malloc((size_t) npair*nchar2*sizeof(int));
  nv = (int *) malloc((size_t) npair*sizeof(int));
  fnval=(double *) malloc((size_t) 1*sizeof(double));
  Q = (double *) malloc(npair*npair*sizeof(double));
  R = (double *) malloc(xcol*xcol*sizeof(double));

  mladistf_getdp(infile,Qfile,ratefile,model,nchar,
		 numsp,nsite,ncatG,kappa,&alpha,
		 aaRmat,&nrates,&smodel,name,seq,
		 fr,&W,&Lam,rate,prob);
  
  /* ML distance calculation */
  mladistf(smodel,nchar,nsite,numsp,seq,nrates,rate,prob,1,&alpha,
	   fr,W,Lam,nv,nxy,M,Mp,Mpp,dmat);
/*   pr_distmat(stdout,numsp,name,dmat); */

  /* variance for distances. probwt should be 0 or 1. probwt=-1 => use LS */
  if(probwt < 0){
    for(i = 0; i < npair; i++) sigma[i]=1.0;
  }
  else{
    varmldistf(nchar,numsp,nxy,nv,nrates,prob,fr,M,Mp,probwt,sigma);
  }
  /* wrow(stdout,npair,sigma,1); */
  

  /* starting tree */
  memcpy(dmatt,dmat,numsp*numsp*sizeof(double));
  if(treefile==NULL){
    nju(numsp,dmatt,utreec);
  }
  else{
    read_treecsnl(treefile,numsp,name,utreec,1);
  }

  gety(numsp, dmat, y);
  for(i = 0; i < npair; i++) y[i] /= sqrt(sigma[i]);

  /* optimize */
  done=-1;
  while(done <= 0){
    ntreesa=spr_search(numsp,ntrees,bl,utreec,fnval,&stop);
    if(!stop){

      if(probwt==2){
	tree2dmat(numsp,dmat,utreec,dmatt,minedge);  
	/* pr_distmat(stdout,numsp,name,dmat); */
	/* pr_distmat(stdout,numsp,name,dmatt); */
	varmldistf_tree(nchar,numsp,nxy,nv,nrates,rate,prob,alpha,fr,smodel,
			W,Lam,dmatt,sigma);
	/* wrow(stdout,npair,sigma,1);  */
	gety(numsp, dmat, y);
	for(i = 0; i < npair; i++) y[i] /= sqrt(sigma[i]);
      }
      else{
	memcpy(yt,y,neig*sizeof(double));
      }
      create_Xmat(numsp, utreec, Xi);
      for(j = 0; j < xcol; j++)
	for(i = 0; i < npair; i++) 
	  X[i+j*npair] = Xi[i+j*npair]/sqrt(sigma[i]);
      if(nneg==1){
	memcpy(yt,y,neig*sizeof(double));
	*fnval=gls_eig_opt(neig, xcol, yt, X, betav);
      }
      if(nneg<=0){
	simp_qr(npair,xcol,X,Q,R);
	*fnval = lsqr(npair,xcol,1,Q,R,yt,betav);
      }
      Xb2utreec(numsp,Xi,betav,utreec);
      /* printf("%f\n",*fnval);  */
    }
    if(stop){
      if(done < 0){
	/* printf("%i trees evaluated\n",ntreesa); */
	if(ntrees > ntreesa || ntrees==-1) ntrees=ntreesa;
	utreec = (double *) realloc(utreec,ntrees*(numsp-1)*4*sizeof(double));
	fnval = (double *) realloc(fnval,ntrees*sizeof(double));
      }
      done++;
    }
  }

  for(i = 0; i < ntrees; i++){
    printf("%f %f ",fnval[i],1-pchisq(fnval[i], neig - (2*numsp - 3)));
    ut2n(numsp,&utreec[i*(numsp-1)*4],name,tree);
    printf("%s ", tree);
    printf("\n");
  }
  return(0);
}
